Index: trunk/NEMO/TOP_SRC/initrc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/initrc.F90	(revision 334)
+++ trunk/NEMO/TOP_SRC/initrc.F90	(revision 335)
@@ -1,64 +1,62 @@
 MODULE initrc
-   !!===========================================================================================
+   !!================================================
    !!
    !!                       *** MODULE initrc ***
    !! Initialisation the tracer model
-   !!===========================================================================================
-
-   !!----------------------------------------------------------------------
-   !!  TOP 1.0,  LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
-   !!----------------------------------------------------------------------
-
-      !!----------------------------------------------------------------------
-      !! * Modules used
-      !! ==============
-      USE oce_trc
-      USE trc
-      USE trcrst
-      USE trcctl
-      USE trclec
-      USE trcdtr
-      USE trcini
-
-      IMPLICIT NONE
-      PRIVATE
-
-
-   !! * Accessibility
-   PUBLIC ini_trc
-
-CONTAINS
+   !!================================================
                                                                                                                             
 #if defined key_passivetrc
 
-SUBROUTINE ini_trc
-   !!---------------------------------------------------------------------
-   !!
-   !!                       ROUTINE ini_trc
-   !!                     ******************
-   !!
-   !!  PURPOSE :
-   !!  ---------
-   !!     initialize the tracer model
-   !!
-   !!   METHOD :
-   !!   -------
-   !!
-   !!
-   !!   History:
-   !!   -------
-   !!      original  : 91-03 ()
-   !!      additions : 92-01 (C. Levy)
-   !!     05-03 (O. Aumont and A. El Moussaoui) F90
-   !!----------------------------------------------------------------------
+   !!-------------------------------------------------------
+   !!  TOP 1.0,  LOCEAN-IPSL (2005)
+   !!-------------------------------------------------------
 
-   !!---------------------------------------------------------------------
-   !!  OPA.9, 03-2005
-   !!---------------------------------------------------------------------
+   !!--------------------------------------------------------------
+   !! * Modules used
+   !! ==============
+   USE oce_trc
+   USE trc
+   USE trcrst
+   USE trcctl
+   USE trclec
+   USE trcdtr
+   USE trcini
+   
+   IMPLICIT NONE
+   PRIVATE
+   
+   
+   !! * Accessibility
+   PUBLIC ini_trc
+   
+CONTAINS
+   
+   SUBROUTINE ini_trc
+      !!---------------------------------------------------------------------
+      !!
+      !!                       ROUTINE ini_trc
+      !!                     ******************
+      !!
+      !!  PURPOSE :
+      !!  ---------
+      !!     initialize the tracer model
+      !!
+      !!   METHOD :
+      !!   -------
+      !!
+      !!
+      !!   History:
+      !!   -------
+      !!      original  : 91-03 ()
+      !!      additions : 92-01 (C. Levy)
+      !!     05-03 (O. Aumont and A. El Moussaoui) F90
+      !!----------------------------------------------------------------------
 
-   !! 0.b PRINT the number of tracer
-   !! ------------------------------
+      !!---------------------------------------------------------------------
+      !!  OPA.9, 03-2005
+      !!---------------------------------------------------------------------
+
+      !! 0.b PRINT the number of tracer
+      !! ------------------------------
 
       IF(lwp) WRITE(numout,*) ' '
@@ -66,40 +64,45 @@
       IF(lwp) WRITE(numout,*) ' '
 
-   ! 1. READ passive tracers namelists
-   ! ---------------------------------
+      ! 1. READ passive tracers namelists
+      ! ---------------------------------
 
       CALL trc_lec
 
-   ! 2. control consistency between parameters, cpp key and namelists
-   ! ----------------------------------------------------------------
+      ! 2. control consistency between parameters, cpp key and namelists
+      ! ----------------------------------------------------------------
 
       CALL trc_ctl
 
-   ! 3. computes some initializations
-   ! --------------------------------
+      ! 3. computes some initializations
+      ! --------------------------------
 
       CALL trc_ini
 
-   ! 4. restart from a FILE (nutrst)
-   ! ----------------------
+      ! 4. restart from a FILE (nutrst)
+      ! ----------------------
 
-      IF(lrsttr) THEN
+      IF( lrsttr ) THEN
 
-          CALL trc_rst
+
+         CALL trc_rst
 
       ELSE
 
-   ! start from anything ELSE
+         ! start from anything ELSE
 
-          CALL trc_dtr
+         CALL trc_dtr
 
       ENDIF
 
-END SUBROUTINE ini_trc
+   END SUBROUTINE ini_trc
 
 #else
-SUBROUTINE ini_trc
-   ! no passive tracers
-END SUBROUTINE ini_trc
+   !!======================================================================
+   !!  Empty module : No passive tracer
+   !!======================================================================
+CONTAINS
+   SUBROUTINE ini_trc
+      
+   END SUBROUTINE ini_trc
 #endif
 
Index: trunk/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/oce_trc.F90	(revision 334)
+++ trunk/NEMO/TOP_SRC/oce_trc.F90	(revision 335)
@@ -41,9 +41,16 @@
       nwrite   =>   nwrite,  & !: frequency of OUTPUT file
       nstock   =>   nstock,  & !: frequency of restart file
+      nprint   =>   nprint,  & !: level of print (0 no print)
       lwp      =>   lwp   ,  & !: boolean term for mpp output
-      ln_ctl   =>   ln_ctl ,  & !: = ln_ctl.AND.lwp (print control on the 1st proc)
-      nictle   =>   nictle ,  & !: = max i indice to make the control SUM
-      njctle   =>   njctle ,  & !: = max j indice to make the control SUM
+      ln_ctl   =>   ln_ctl,  & !: = ln_ctl.AND.lwp (print control on the 1st proc)
+      nictls   =>   nictls,  & !: Start i indice for the SUM control
+      nictle   =>   nictle,  & !: End   i indice for the SUM control
+      njctls   =>   njctls,  & !: Start j indice for the SUM control
+      njctle   =>   njctle,  & !: End   j indice for the SUM control
+      isplt    =>   isplt ,  & !: number of processors following i
+      jsplt    =>   jsplt ,  & !: number of processors following j
+      ijsplt   =>   ijsplt,  & !: nb of local domain = nb of processors
       numout   =>   numout     !: logical unit for output print
+
 
    !! run controm   
@@ -73,4 +80,6 @@
       nimpp    =>   nimpp ,  & !: i index for mpp-subdomain left bottom
       njmpp    =>   njmpp ,  & !: j index for mpp-subdomain left bottom
+      nproc    =>   nproc ,  & !: number for local processor
+      narea    =>   narea ,  & !: number for local area
       mig      =>   mig   ,  & !: local  ==> global  domain i-indice
       mjg      =>   mjg   ,  & !: local  ==> global  domain i-indice
@@ -79,5 +88,18 @@
       mj0      =>   mj0   ,  & !: global ==> local domain j-indice 
       mj1      =>   mj1        !: (mj0=1 and mj1=0 if the global indice is not in the local domain)
-      
+ 
+   USE dom_oce , ONLY :       & 
+      nimppt   => nimppt  ,  & !:i-indexes for each processor
+      njmppt   => njmppt  ,  & !:j-indexes for each processor
+      ibonit   => ibonit  ,  & !:i-processor neighbour existence
+      ibonjt   => ibonjt  ,  & !:j- processor neighbour existence 
+      nlcit    => nlcit   ,  & !:dimensions of every i-subdomain
+      nlcjt    => nlcjt   ,  & !:dimensions of every j-subdomain
+      nldit    => nldit   ,  & !:first indoor index for each i-domain 
+      nleit    => nleit   ,  & !:last indoor index for each i-domain 
+      nldjt    => nldjt   ,  & !:first indoor index for each j-domain 
+      nlejt    => nlejt        !:last indoor index for each j-domain 
+
+    
       !! horizontal curvilinear coordinate and scale factors
    USE dom_oce , ONLY :            &    
@@ -198,5 +220,11 @@
       tn      =>    tn    ,  & !: pot. temperature (celsius)
       sn      =>    sn    ,  & !: salinity (psu)
-      rhop    =>    rhop       !: potential volumic mass (kg m-3) 
+      rhop    =>    rhop  ,  & !: potential volumic mass (kg m-3) 
+      rhd     =>    rhd        !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
+
+#if defined key_trc_diatrd
+   USE oce , ONLY :          &
+      hdivn   =>    hdivn      !: horizontal divergence (1/s)
+#endif
 
 #if defined key_flx_bulk_monthly || defined key_flx_bulk_daily
@@ -214,4 +242,9 @@
    USE trabbl , ONLY :           &      
       atrbbl   =>   atrbbl     !: lateral coeff. for bottom boundary layer scheme (m2/s)
+#  if defined key_off_tra
+   USE trabbl, ONLY :            &
+      bblx   => bblx,       &
+      bbly   => bbly
+#  endif
 #endif
 
@@ -262,5 +295,6 @@
    USE zdfmxl , ONLY :             &    
       hmld    =>   hmld   ,  & !: mixing layer depth (turbocline)
-      hmlp    =>   hmlp        !: mixed layer depth  (rho=rho0+zdcrit) (m)
+      hmlp    =>   hmlp   ,  & !: mixed layer depth  (rho=rho0+zdcrit) (m)
+      hmlpt   =>   hmlpt       !: mixed layer depth at t-points (m)
 
    USE ldfslp , ONLY :              & 
Index: trunk/NEMO/TOP_SRC/par_trc_trp.F90
===================================================================
--- trunk/NEMO/TOP_SRC/par_trc_trp.F90	(revision 334)
+++ trunk/NEMO/TOP_SRC/par_trc_trp.F90	(revision 335)
@@ -8,6 +8,4 @@
    !!----------------------------------------------------------------------
    !!  TOP 1.0,  LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
    !!----------------------------------------------------------------------
 #if defined key_passivetrc
@@ -23,89 +21,22 @@
    !! jpdia3d : additional 3d output
 
-#if defined key_trc_npzd
-   !!---------------------------------------------------------------------
-   !!   'key_trc_npzd'   :                    NPZD Source Minus Sink model
-   !!---------------------------------------------------------------------
-   INTEGER, PUBLIC, PARAMETER :: jptra   = 4
-#if defined key_trc_diaadd
-   INTEGER, PUBLIC, PARAMETER :: jpdia2d = 1
-   INTEGER, PUBLIC, PARAMETER :: jpdia3d = 1
-#endif
-#elif defined key_trc_lobster1
+#if defined key_trc_lobster1
    !!---------------------------------------------------------------------
    !!   'key_trc_lobster1'   :            LOBSTER1 Source Minus Sink model
    !!---------------------------------------------------------------------
    INTEGER, PUBLIC, PARAMETER :: jptra   = 6
-#if defined key_trc_diaadd
-   INTEGER, PUBLIC, PARAMETER :: jpdia2d = 18
+#  if defined key_trc_diaadd
+   INTEGER, PUBLIC, PARAMETER :: jpdia2d = 19
    INTEGER, PUBLIC, PARAMETER :: jpdia3d = 3
-#endif
-#elif defined key_trc_hamocc3
-#  if defined key_trc_p3zd
-#       if defined key_trc_biohamocc13
+#  endif
+#elif defined key_cfc
    !!---------------------------------------------------------------------
-   !!   'key_trc_p3zd && key_trc_biohamocc13' P3ZD Source Minus Sink model
+   !!   'key_cfc'   :                      CFC Source Minus Sink model
    !!---------------------------------------------------------------------
-   INTEGER, PUBLIC, PARAMETER :: jptra   = 11
-#if defined key_trc_diaadd
+   INTEGER, PUBLIC, PARAMETER :: jptra   = 2
+#  if defined key_trc_diaadd
    INTEGER, PUBLIC, PARAMETER :: jpdia2d = 1
    INTEGER, PUBLIC, PARAMETER :: jpdia3d = 1
-#endif
-   !!---------------------------------------------------------------------
-   !!   'key_trc_p3zd'   :                    P3ZD Source Minus Sink model
-   !!---------------------------------------------------------------------
-#       else
-   INTEGER, PUBLIC, PARAMETER :: jptra   = 10
-   INTEGER, PUBLIC, PARAMETER :: jpdia2d = 1
-   INTEGER, PUBLIC, PARAMETER :: jpdia3d = 1
-#       endif
-#   else
-   !!---------------------------------------------------------------------
-   !!  'key_trc_hamocc3 && key_trc_biohamocc13' HAMMOCC Source Minus Sink model
-   !!---------------------------------------------------------------------
-#       if defined key_trc_biohamocc13
-   INTEGER, PUBLIC, PARAMETER :: jptra   = 8
-#if defined key_trc_diaadd
-   INTEGER, PUBLIC, PARAMETER :: jpdia2d = 1
-   INTEGER, PUBLIC, PARAMETER :: jpdia3d = 1
-#endif
-#       else
-   !!---------------------------------------------------------------------
-   !!  'key_trc_hamocc3 ' HAMMOCC Source Minus Sink model
-   !!---------------------------------------------------------------------
-   INTEGER, PUBLIC, PARAMETER :: jptra   = 7
-#if defined key_trc_diaadd
-   INTEGER, PUBLIC, PARAMETER :: jpdia2d = 1
-   INTEGER, PUBLIC, PARAMETER :: jpdia3d = 1
-#endif
-#       endif
-#   endif
-#elif defined key_cfc
-   !!---------------------------------------------------------------------
-   !!   'key_trc_cfc'   :                      CFC Source Minus Sink model
-   !!---------------------------------------------------------------------
-   INTEGER, PUBLIC, PARAMETER :: jptra   = 2
-#if defined key_trc_diaadd
-   INTEGER, PUBLIC, PARAMETER :: jpdia2d = 1
-   INTEGER, PUBLIC, PARAMETER :: jpdia3d = 1
-#endif
-#elif defined key_gosac
-   !!---------------------------------------------------------------------
-   !!   'key_trc_gosac'   :                  GOSAC Source Minus Sink model
-   !!---------------------------------------------------------------------
-   INTEGER, PUBLIC, PARAMETER :: jptra   = 2
-#if defined key_trc_diaadd
-   INTEGER, PUBLIC, PARAMETER :: jpdia2d = 1
-   INTEGER, PUBLIC, PARAMETER :: jpdia3d = 1
-#endif
-#elif defined key_trc_age
-   !!---------------------------------------------------------------------
-   !!   'key_trc_age'   :                    AGE Source Minus Sink model
-   !!---------------------------------------------------------------------
-   INTEGER, PUBLIC, PARAMETER :: jptra   = 2
-#if defined key_trc_diaadd
-   INTEGER, PUBLIC, PARAMETER :: jpdia2d = 1
-   INTEGER, PUBLIC, PARAMETER :: jpdia3d = 1
-#endif
+#  endif
 #elif defined key_trc_pisces
    !!---------------------------------------------------------------------
@@ -113,8 +44,8 @@
    !!---------------------------------------------------------------------
    INTEGER, PUBLIC, PARAMETER :: jptra   = 24
-#if defined key_trc_diaadd
+#  if defined key_trc_diaadd
    INTEGER, PUBLIC, PARAMETER :: jpdia2d = 13
    INTEGER, PUBLIC, PARAMETER :: jpdia3d = 11
-#endif
+#  endif
 #else
    !!---------------------------------------------------------------------
Index: trunk/NEMO/TOP_SRC/trc.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trc.F90	(revision 334)
+++ trunk/NEMO/TOP_SRC/trc.F90	(revision 335)
@@ -11,6 +11,4 @@
    !!----------------------------------------------------------------------
    !!  TOP 1.0,  LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
    !!----------------------------------------------------------------------
 #if defined key_passivetrc
@@ -193,8 +191,4 @@
 #endif
 
-   !! Contral/debugging
-   !! -----------------
-   REAL(wp), PUBLIC, DIMENSION(jptra) ::  & 
-      tra_ctl         !!: sum of tra trend
 #else
    !!======================================================================
Index: trunk/NEMO/TOP_SRC/trcctl.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcctl.F90	(revision 334)
+++ trunk/NEMO/TOP_SRC/trcctl.F90	(revision 335)
@@ -10,61 +10,58 @@
    !!=========================================================================
    !!  TOP 1.0,  LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
    !!----------------------------------------------------------------------
-      !!----------------------------------------------------------------------
-      !! * Modules used
-      !! ==============
-      USE oce_trc
-      USE trc
-      USE sms
-      USE trctrp_ctl
+#if defined key_passivetrc
+   !!----------------------------------------------------------------------
+   !! * Modules used
+   !! ==============
+   USE oce_trc
+   USE trc
+   USE sms
+   USE trctrp_ctl
 
-     IMPLICIT NONE
-     PRIVATE
+   IMPLICIT NONE
+   PRIVATE
 
-    !! * Accessibility
-    PUBLIC trc_ctl
+   !! * Accessibility
+   PUBLIC trc_ctl
 
 CONTAINS
 
-#if defined key_passivetrc
+   SUBROUTINE trc_ctl
+      !!===========================================================================================
+      !!
+      !!
+      !!                       ROUTINE trcctl
+      !!                     ******************
+      !!
+      !!      we use IF/ENDIF inside #IF defined option-cpp
+      !!      FILE name must not exceed 21 characters
+      !!      
+      !!===========================================================================================
+      
+      !!----------------------------------------------------------------------
+      !! local declarations
+      !! ==================
+      INTEGER  :: istop, jn
+      
+      !!---------------------------------------------------------------------
+      !!  OPA.9    03/2005  
+      !!---------------------------------------------------------------------
 
-SUBROUTINE trc_ctl
-   !!===========================================================================================
-   !!
-   !!
-   !!                       ROUTINE trcctl
-   !!                     ******************
-   !!
-   !!      we use IF/ENDIF inside #IF defined option-cpp
-   !!      FILE name must not exceed 21 characters
-   !!      
-   !!===========================================================================================
-     
-   !!----------------------------------------------------------------------
-   !! local declarations
-   !! ==================
-   INTEGER  :: istop, jn
-
-!!!---------------------------------------------------------------------
-!!!  OPA.9    03/2005  
-!!!---------------------------------------------------------------------
-
-! 0. Parameter
-! ------------
+      ! 0. Parameter
+      ! ------------
       istop = 0
 
-! 1. LOGICAL UNIT initialization for specifi! files for passive tracer
-! --------------------------------------------------------------------
-!     nutwrs : OUTPUT for passive tracer restart UNIT (always used)
-!     nutrst : restart FILE  INPUT  UNIT (lrsttr=.TRUE.)
-!     nutini(jptra) : UNIT for initial FILE for tracer
+      ! 1. LOGICAL UNIT initialization for specifi! files for passive tracer
+      ! --------------------------------------------------------------------
+      !     nutwrs : OUTPUT for passive tracer restart UNIT (always used)
+      !     nutrst : restart FILE  INPUT  UNIT (lrsttr=.TRUE.)
+      !     nutini(jptra) : UNIT for initial FILE for tracer
 
       nutwrs = 72
       nutrst = 73
 
-! 2. restart for passive tracer (input)
-! -----------------------------
+      ! 2. restart for passive tracer (input)
+      ! -----------------------------
 
       IF(lwp) WRITE(numout,*) ' '
@@ -78,51 +75,50 @@
 
       IF(lrsttr) THEN
-          IF(lwp) WRITE(numout,*) ' READ a restart FILE for passive tracer'
-          IF(lwp) WRITE(numout,*) ' '
+         IF(lwp) WRITE(numout,*) ' READ a restart FILE for passive tracer'
+         IF(lwp) WRITE(numout,*) ' '
       ELSE
-          IF(lwp) WRITE(numout,*) ' no restart FILE'
-          IF(lwp) WRITE(numout,*) ' '
+         IF(lwp) WRITE(numout,*) ' no restart FILE'
+         IF(lwp) WRITE(numout,*) ' '
 
-! 3. OPEN FILES for initial tracer value
-! --------------------------------------
-          DO jn=1,jptra
+         ! 3. OPEN FILES for initial tracer value
+         ! --------------------------------------
+         DO jn=1,jptra
 
-! OPEN input FILE only IF lutini(jn) is true
-! ------------------------------------------
+            ! OPEN input FILE only IF lutini(jn) is true
+            ! ------------------------------------------
             IF (lutini(jn)) THEN  
 
-! prepare input FILE name a
-! -------------------------                        
-                IF(lwp) WRITE(numout,*)                          &
-                        ' READ an initial FILE :',               &
-                        ' for passive tracer number :',jn        &
-                        ,' traceur : ',ctrcnm(jn) 
-                IF(lwp) WRITE(numout,*) ' '
-            END IF 
-          END DO   
+               ! prepare input FILE name a
+               ! -------------------------                        
+               IF(lwp) WRITE(numout,*)  &
+                  ' READ an initial FILE  for passive tracer number :',jn        &
+                  ,' traceur : ',ctrcnm(jn) 
+               IF(lwp) WRITE(numout,*) ' '
+            END IF
+         END DO
       ENDIF
 
-! 4. Don't USE non penetrative convective mixing option
-!     it's not implemented for passive tracer
-! -----------------------------------------------------
+      ! 4. Don't USE non penetrative convective mixing option
+      !     it's not implemented for passive tracer
+      ! -----------------------------------------------------
 
       IF( ln_zdfnpc) THEN
-        IF(lwp) WRITE (numout,*) ' ===>>>> : w a r n i n g '
-        IF(lwp) WRITE (numout,*) ' =======   ============= '
-        IF(lwp) WRITE (numout,*) ' STOP, this sheme is not implemented'
-        IF(lwp) WRITE (numout,*) ' in passive tracer model:'
-        IF(lwp) WRITE (numout,*) ' non penetrative convect. mixing scheme'
-        istop = istop + 1
+         IF(lwp) WRITE (numout,*) ' ===>>>> : w a r n i n g '
+         IF(lwp) WRITE (numout,*) ' =======   ============= '
+         IF(lwp) WRITE (numout,*) ' STOP, this sheme is not implemented'
+         IF(lwp) WRITE (numout,*) ' in passive tracer model:'
+         IF(lwp) WRITE (numout,*) ' non penetrative convect. mixing scheme'
+         istop = istop + 1
       ENDIF
 
-! 5. transport scheme option
-! --------------------------
+      ! 5. transport scheme option
+      ! --------------------------
 
       IF(lwp) WRITE(numout,*) '  '
       CALL trc_trp_ctl
-      IF(lwp) WRITE(numout,*) '  '
 
-! 6. SMS model
-! ---------------------------------------------
+
+      ! 6. SMS model
+      ! ---------------------------------------------
 
       IF(lwp) WRITE(numout,*) '  '
@@ -130,16 +126,11 @@
       IF(lwp) WRITE(numout,*) '  '
 
-#if defined key_trc_npzd
-      #include "trcctl.npzd.h90" 
-#elif defined key_trc_lobster1
-      #include "trcctl.lobster1.h90"
+
+#if defined key_trc_lobster1
+#   include "trcctl.lobster1.h90"
 #elif defined key_trc_pisces
-      #include "trcctl.pisces.h90"
-#elif defined key_trc_hamocc3
-#   if defined key_trc_p3zd
-      #include "trcctl.p3zd.h90"
-#   else
-      #include "trcctl.hamocc3.h90"
-#   endif
+#   include "trcctl.pisces.h90"
+#elif defined key_cfc
+#   include "trcctl.cfc.h90"
 #else
 
@@ -148,25 +139,26 @@
 #endif
 
-! E r r o r  control
-! ------------------
+      ! E r r o r  control
+      ! ------------------
 
       IF ( istop > 0  ) THEN
-          IF(lwp)WRITE(numout,*)
-          IF(lwp)WRITE(numout,*) istop,' E R R O R found : we stop'
-          IF(lwp)WRITE(numout,*) '**************************'
-          IF(lwp)WRITE(numout,*)
-          STOP 'trcctl'
+         IF(lwp)WRITE(numout,*)
+         IF(lwp)WRITE(numout,*) istop,' E R R O R found : we stop'
+         IF(lwp)WRITE(numout,*) '**************************'
+         IF(lwp)WRITE(numout,*)
+         STOP 'trcctl'
       ENDIF
 
-END SUBROUTINE trc_ctl 
+   END SUBROUTINE trc_ctl
 
 #else
+   !!======================================================================
+   !!  Empty module : No passive tracer
+   !!======================================================================
+CONTAINS
+   SUBROUTINE trc_ctl
 
-SUBROUTINE trc_ctl
-  !!==============
-         ! no passive tracers
-  !!==============
-END SUBROUTINE trc_ctl
-
+   END SUBROUTINE trc_ctl
+   
 #endif
 
Index: trunk/NEMO/TOP_SRC/trcdia.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcdia.F90	(revision 334)
+++ trunk/NEMO/TOP_SRC/trcdia.F90	(revision 335)
@@ -7,10 +7,9 @@
    !!==========================================================================
    !!  TOP 1.0,  LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
    !!----------------------------------------------------------------------
-      !!----------------------------------------------------------------------
-      !! * Modules used
-      !! ==============
+#if defined key_passivetrc
+   !!----------------------------------------------------------------------
+   !! * Modules used
+ 
    USE trcdit
 
@@ -25,14 +24,14 @@
 CONTAINS
 
-SUBROUTINE trc_dia(kt,kindic)  
-   !!===========================================================================================
-   !!
-   !!                       ROUTINE trcdii_wr
-   !!===========================================================================================
+   SUBROUTINE trc_dia(kt,kindic)  
+      !!===========================================================================================
+      !!
+      !!                       ROUTINE trcdii_wr
+      !!===========================================================================================
 
-       INTEGER, INTENT( in ) :: kt, kindic
+      INTEGER, INTENT( in ) :: kt, kindic
 
-   ! outputs for tracer concentration
-   ! -------------------------------- 
+      ! outputs for tracer concentration
+      ! -------------------------------- 
 
       CALL trcdit_wr(kt,kindic)
@@ -40,6 +39,6 @@
 #if defined key_trc_diatrd
 
-   ! outputs for dynamical trends
-   ! ----------------------------
+      ! outputs for dynamical trends
+      ! ----------------------------
 
       CALL trcdid_wr(kt,kindic)
@@ -48,6 +47,6 @@
 #if defined key_trc_diaadd
 
-   ! outputs for additional arrays
-   ! -----------------------------
+      ! outputs for additional arrays
+      ! -----------------------------
 
       CALL trcdii_wr(kt,kindic)
@@ -56,6 +55,6 @@
 #if defined key_trc_diabio
 
-   ! outputs for biological trends
-   ! -----------------------------
+      ! outputs for biological trends
+      ! -----------------------------
 
       CALL trcdib_wr(kt,kindic)
@@ -63,5 +62,15 @@
 #endif
 
-      END SUBROUTINE trc_dia
+   END SUBROUTINE trc_dia
 
-END MODULE trcdia 
+#else
+   !!======================================================================
+   !!  Empty module : No passive tracer
+   !!======================================================================
+CONTAINS
+   SUBROUTINE trc_dia
+      
+   END SUBROUTINE trc_dia   
+#endif
+
+END MODULE trcdia
Index: trunk/NEMO/TOP_SRC/trcdit.F90
===================================================================
--- trunk/NEMO/TOP_SRC/trcdit.F90	(revision 334)
+++ trunk/NEMO/TOP_SRC/trcdit.F90	(revision 335)
@@ -1,12 +1,8 @@
 MODULE trcdit
-
    !!----------------------------------------------------------------------
    !!  TOP 1.0,  LOCEAN-IPSL (2005)
-   !! $Header$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt
    !!----------------------------------------------------------------------
-      !!----------------------------------------------------------------------
-      !! * Modules used
-      !! ==============
+   !! * Modules used
+   !! ==============
    USE oce_trc
    USE trc
@@ -49,5 +45,5 @@
       nitb     ,   &  !!:  id for additional array output FILE
       ndepitb  ,   &  !!:  id for depth mesh
-      nhoritb  ,   &  !!:  id for horizontal mesh
+      nhoritb         !!:  id for horizontal mesh
 #    endif
 
@@ -447,5 +443,5 @@
                   cltrau=ctrcun(jn) ! UNIT for tracer /trends
                   CALL histdef(nit6(jn), cltra, cltral, cltrau, jpi,jpj,  &
-                  &   nhorit6(jn), ipk, 1, ipk,  ndepit6(jn), 32, clop,
+                  &   nhorit6(jn), ipk, 1, ipk,  ndepit6(jn), 32, clop ,  &
                   &   zsto,zout)
                 END DO
@@ -809,9 +805,10 @@
       !! Modules used
       USE ioipsl
+      USE sms
 
       !! * Arguments
       INTEGER, INTENT( in ) ::   kt,kindic         ! ocean time-step
 
-      INTEGER :: ji, jj, jk, jn, jl
+      INTEGER :: ji, jj, jk, jn
       LOGICAL :: ll_print = .FALSE.
 
@@ -821,5 +818,4 @@
 
       REAL(wp) :: zsto, zout, zdt
-      REAL(wp) :: zsec
       INTEGER  :: iimi, iima, ijmi, ijma, ipk, it
 
@@ -848,4 +844,5 @@
 
       ! Define indices of the horizontal output zoom and vertical limit storage      iimi = 1      ;      iima = jpi
+      iimi = 1      ;      iima = jpi
       ijmi = 1      ;      ijma = jpj
       ipk = jpk
@@ -895,5 +892,5 @@
 ! SOME diagnostics to DO first time
 
-#        if defined key_trc_npzd || defined key_trc_lobster1
+#  if defined key_trc_lobster1
 
 ! initial total nitrogen
@@ -947,9 +944,8 @@
       DO jn=1,jpdiabio
          cltra=ctrbio(jn)  ! short title for biological diagnostic
-         CALL histwrite(nitb, cltra, zt, trbio(:,:,:,jn), ndimt50,   &
-         &    ndext50)
+         CALL histwrite(nitb, cltra, kt, trbio(:,:,:,jn), ndimt50,ndext50)
       END DO
 
-#     if defined key_trc_npzd || defined key_trc_lobster1
+#  if  defined key_trc_lobster1
 
       IF( MOD(kt-nit000+1,nwritebio) == 0) THEN
